Loading...
Searching...
No Matches
or/unmtr: Multiply by Q from tridiagonal reduction
Dense LA » Eigenvalues » Symmetric/Hermitian eigenvalues

## Functions

magma_int_t | magma_cunmtr (magma_side_t side, magma_uplo_t uplo, magma_trans_t trans, magma_int_t m, magma_int_t n, magmaFloatComplex *A, magma_int_t lda, magmaFloatComplex *tau, magmaFloatComplex *C, magma_int_t ldc, magmaFloatComplex *work, magma_int_t lwork, magma_int_t *info)
| CUNMTR overwrites the general complex M-by-N matrix C with.
magma_int_t | magma_cunmtr_gpu (magma_side_t side, magma_uplo_t uplo, magma_trans_t trans, magma_int_t m, magma_int_t n, magmaFloatComplex_ptr dA, magma_int_t ldda, magmaFloatComplex *tau, magmaFloatComplex_ptr dC, magma_int_t lddc, const magmaFloatComplex *wA, magma_int_t ldwa, magma_int_t *info)
| CUNMTR overwrites the general complex M-by-N matrix C with.
magma_int_t | magma_cunmtr_m (magma_int_t ngpu, magma_side_t side, magma_uplo_t uplo, magma_trans_t trans, magma_int_t m, magma_int_t n, magmaFloatComplex *A, magma_int_t lda, magmaFloatComplex *tau, magmaFloatComplex *C, magma_int_t ldc, magmaFloatComplex *work, magma_int_t lwork, magma_int_t *info)
| CUNMTR overwrites the general complex M-by-N matrix C with.
magma_int_t | magma_dormtr (magma_side_t side, magma_uplo_t uplo, magma_trans_t trans, magma_int_t m, magma_int_t n, double *A, magma_int_t lda, double *tau, double *C, magma_int_t ldc, double *work, magma_int_t lwork, magma_int_t *info)
| DORMTR overwrites the general real M-by-N matrix C with.
magma_int_t | magma_dormtr_gpu (magma_side_t side, magma_uplo_t uplo, magma_trans_t trans, magma_int_t m, magma_int_t n, magmaDouble_ptr dA, magma_int_t ldda, double *tau, magmaDouble_ptr dC, magma_int_t lddc, const double *wA, magma_int_t ldwa, magma_int_t *info)
| DORMTR overwrites the general real M-by-N matrix C with.
magma_int_t | magma_dormtr_m (magma_int_t ngpu, magma_side_t side, magma_uplo_t uplo, magma_trans_t trans, magma_int_t m, magma_int_t n, double *A, magma_int_t lda, double *tau, double *C, magma_int_t ldc, double *work, magma_int_t lwork, magma_int_t *info)
| DORMTR overwrites the general real M-by-N matrix C with.
magma_int_t | magma_sormtr (magma_side_t side, magma_uplo_t uplo, magma_trans_t trans, magma_int_t m, magma_int_t n, float *A, magma_int_t lda, float *tau, float *C, magma_int_t ldc, float *work, magma_int_t lwork, magma_int_t *info)
| SORMTR overwrites the general real M-by-N matrix C with.
magma_int_t | magma_sormtr_gpu (magma_side_t side, magma_uplo_t uplo, magma_trans_t trans, magma_int_t m, magma_int_t n, magmaFloat_ptr dA, magma_int_t ldda, float *tau, magmaFloat_ptr dC, magma_int_t lddc, const float *wA, magma_int_t ldwa, magma_int_t *info)
| SORMTR overwrites the general real M-by-N matrix C with.
magma_int_t | magma_sormtr_m (magma_int_t ngpu, magma_side_t side, magma_uplo_t uplo, magma_trans_t trans, magma_int_t m, magma_int_t n, float *A, magma_int_t lda, float *tau, float *C, magma_int_t ldc, float *work, magma_int_t lwork, magma_int_t *info)
| SORMTR overwrites the general real M-by-N matrix C with.
magma_int_t | magma_zunmtr (magma_side_t side, magma_uplo_t uplo, magma_trans_t trans, magma_int_t m, magma_int_t n, magmaDoubleComplex *A, magma_int_t lda, magmaDoubleComplex *tau, magmaDoubleComplex *C, magma_int_t ldc, magmaDoubleComplex *work, magma_int_t lwork, magma_int_t *info)
| ZUNMTR overwrites the general complex M-by-N matrix C with.
magma_int_t | magma_zunmtr_gpu (magma_side_t side, magma_uplo_t uplo, magma_trans_t trans, magma_int_t m, magma_int_t n, magmaDoubleComplex_ptr dA, magma_int_t ldda, magmaDoubleComplex *tau, magmaDoubleComplex_ptr dC, magma_int_t lddc, const magmaDoubleComplex *wA, magma_int_t ldwa, magma_int_t *info)
| ZUNMTR overwrites the general complex M-by-N matrix C with.
magma_int_t | magma_zunmtr_m (magma_int_t ngpu, magma_side_t side, magma_uplo_t uplo, magma_trans_t trans, magma_int_t m, magma_int_t n, magmaDoubleComplex *A, magma_int_t lda, magmaDoubleComplex *tau, magmaDoubleComplex *C, magma_int_t ldc, magmaDoubleComplex *work, magma_int_t lwork, magma_int_t *info)
| ZUNMTR overwrites the general complex M-by-N matrix C with.

## Detailed Description

## Function Documentation

## magma_cunmtr()

magma_int_t magma_cunmtr | ( | magma_side_t | side,
|  | magma_uplo_t | uplo,
|  | magma_trans_t | trans,
|  | magma_int_t | m,
|  | magma_int_t | n,
|  | magmaFloatComplex * | A,
|  | magma_int_t | lda,
|  | magmaFloatComplex * | tau,
|  | magmaFloatComplex * | C,
|  | magma_int_t | ldc,
|  | magmaFloatComplex * | work,
|  | magma_int_t | lwork,
|  | magma_int_t * | info )

CUNMTR overwrites the general complex M-by-N matrix C with.

                            SIDE = MagmaLeft    SIDE = MagmaRight

TRANS = MagmaNoTrans: Q * C C * Q TRANS = Magma_ConjTrans: Q**H * C C * Q**H

where Q is a complex unitary matrix of order nq, with nq = m if SIDE = MagmaLeft and nq = n if SIDE = MagmaRight. Q is defined as the product of nq-1 elementary reflectors, as returned by CHETRD:

if UPLO = MagmaUpper, Q = H(nq-1) . . . H(2) H(1);

if UPLO = MagmaLower, Q = H(1) H(2) . . . H(nq-1).

Parameters

  [in]

  side

  magma_side_t
  - = MagmaLeft: apply Q or Q**H from the Left;
  - = MagmaRight: apply Q or Q**H from the Right.

  [in]

  uplo

  magma_uplo_t
  - = MagmaUpper: Upper triangle of A contains elementary reflectors from CHETRD;
  - = MagmaLower: Lower triangle of A contains elementary reflectors from CHETRD.

  [in]

  trans

  magma_trans_t
  - = MagmaNoTrans: No transpose, apply Q;
  - = Magma_ConjTrans: Conjugate transpose, apply Q**H.

  [in] | m | INTEGER The number of rows of the matrix C. M >= 0.
  [in] | n | INTEGER The number of columns of the matrix C. N >= 0.
  [in] | A | COMPLEX array, dimension (LDA,M) if SIDE = MagmaLeft (LDA,N) if SIDE = MagmaRight The vectors which define the elementary reflectors, as returned by CHETRD.
  [in] | lda | INTEGER The leading dimension of the array A. LDA >= max(1,M) if SIDE = MagmaLeft; LDA >= max(1,N) if SIDE = MagmaRight.
  [in] | tau | COMPLEX array, dimension (M-1) if SIDE = MagmaLeft (N-1) if SIDE = MagmaRight TAU(i) must contain the scalar factor of the elementary reflector H(i), as returned by CHETRD.
  [in,out] | C | COMPLEX array, dimension (LDC,N) On entry, the M-by-N matrix C. On exit, C is overwritten by Q*C or Q**H * C or C * Q**H or C*Q.
  [in] | ldc | INTEGER The leading dimension of the array C. LDC >= max(1,M).
  [out] | work | (workspace) COMPLEX array, dimension (MAX(1,LWORK)) On exit, if INFO = 0, WORK[0] returns the optimal LWORK.

  [in]

  lwork

  INTEGER The dimension of the array WORK. If SIDE = MagmaLeft, LWORK >= max(1,N); if SIDE = MagmaRight, LWORK >= max(1,M). For optimum performance LWORK >= N*NB if SIDE = MagmaLeft, and LWORK >= M*NB if SIDE = MagmaRight, where NB is the optimal blocksize.
  If LWORK = -1, then a workspace query is assumed; the routine only calculates the optimal size of the WORK array, returns this value as the first entry of the WORK array, and no error message related to LWORK is issued.

  [out]

  info

  INTEGER
  - = 0: successful exit
  - < 0: if INFO = -i, the i-th argument had an illegal value

## magma_cunmtr_gpu()

magma_int_t magma_cunmtr_gpu | ( | magma_side_t | side,
|  | magma_uplo_t | uplo,
|  | magma_trans_t | trans,
|  | magma_int_t | m,
|  | magma_int_t | n,
|  | magmaFloatComplex_ptr | dA,
|  | magma_int_t | ldda,
|  | magmaFloatComplex * | tau,
|  | magmaFloatComplex_ptr | dC,
|  | magma_int_t | lddc,
|  | const magmaFloatComplex * | wA,
|  | magma_int_t | ldwa,
|  | magma_int_t * | info )

CUNMTR overwrites the general complex M-by-N matrix C with.

                            SIDE = MagmaLeft    SIDE = MagmaRight

TRANS = MagmaNoTrans: Q * C C * Q TRANS = Magma_ConjTrans: Q**H * C C * Q**H

where Q is a complex unitary matrix of order nq, with nq = m if SIDE = MagmaLeft and nq = n if SIDE = MagmaRight. Q is defined as the product of nq-1 elementary reflectors, as returned by CHETRD:

if UPLO = MagmaUpper, Q = H(nq-1) . . . H(2) H(1);

if UPLO = MagmaLower, Q = H(1) H(2) . . . H(nq-1).

Parameters

  [in]

  side

  magma_side_t
  - = MagmaLeft: apply Q or Q**H from the Left;
  - = MagmaRight: apply Q or Q**H from the Right.

  [in]

  uplo

  magma_uplo_t
  - = MagmaUpper: Upper triangle of A contains elementary reflectors from CHETRD;
  - = MagmaLower: Lower triangle of A contains elementary reflectors from CHETRD.

  [in]

  trans

  magma_trans_t
  - = MagmaNoTrans: No transpose, apply Q;
  - = Magma_ConjTrans: Conjugate transpose, apply Q**H.

  [in] | m | INTEGER The number of rows of the matrix C. M >= 0.
  [in] | n | INTEGER The number of columns of the matrix C. N >= 0.
  [in,out] | dA | COMPLEX array, dimension (LDDA,M) if SIDE = MagmaLeft (LDDA,N) if SIDE = MagmaRight The vectors which define the elementary reflectors, as returned by CHETRD_GPU. On output the diagonal, the subdiagonal and the upper part (UPLO=MagmaLower) or lower part (UPLO=MagmaUpper) are destroyed.
  [in] | ldda | INTEGER The leading dimension of the array dA. If SIDE = MagmaLeft, LDDA >= max(1,M); if SIDE = MagmaRight, LDDA >= max(1,N).
  [in] | tau | COMPLEX array, dimension (M-1) if SIDE = MagmaLeft (N-1) if SIDE = MagmaRight TAU(i) must contain the scalar factor of the elementary reflector H(i), as returned by CHETRD.
  [in,out] | dC | COMPLEX array, dimension (LDDC,N) On entry, the M-by-N matrix C. On exit, C is overwritten by (Q*C) or (Q**H * C) or (C * Q**H) or (C*Q).
  [in] | lddc | INTEGER The leading dimension of the array C. LDDC >= max(1,M).
  [in] | wA | COMPLEX array, dimension (LDWA,M) if SIDE = MagmaLeft (LDWA,N) if SIDE = MagmaRight The vectors which define the elementary reflectors, as returned by CHETRD_GPU. (A copy of the upper or lower part of dA, on the host.)
  [in] | ldwa | INTEGER The leading dimension of the array wA. If SIDE = MagmaLeft, LDWA >= max(1,M); if SIDE = MagmaRight, LDWA >= max(1,N).

  [out]

  info

  INTEGER
  - = 0: successful exit
  - < 0: if INFO = -i, the i-th argument had an illegal value

## magma_cunmtr_m()

magma_int_t magma_cunmtr_m | ( | magma_int_t | ngpu,
|  | magma_side_t | side,
|  | magma_uplo_t | uplo,
|  | magma_trans_t | trans,
|  | magma_int_t | m,
|  | magma_int_t | n,
|  | magmaFloatComplex * | A,
|  | magma_int_t | lda,
|  | magmaFloatComplex * | tau,
|  | magmaFloatComplex * | C,
|  | magma_int_t | ldc,
|  | magmaFloatComplex * | work,
|  | magma_int_t | lwork,
|  | magma_int_t * | info )

CUNMTR overwrites the general complex M-by-N matrix C with.

                            SIDE = MagmaLeft    SIDE = MagmaRight

TRANS = MagmaNoTrans: Q * C C * Q TRANS = Magma_ConjTrans: Q**H * C C * Q**H

where Q is a complex unitary matrix of order nq, with nq = m if SIDE = MagmaLeft and nq = n if SIDE = MagmaRight. Q is defined as the product of nq-1 elementary reflectors, as returned by CHETRD:

if UPLO = MagmaUpper, Q = H(nq-1) . . . H(2) H(1);

if UPLO = MagmaLower, Q = H(1) H(2) . . . H(nq-1).

Parameters

  [in] | ngpu | INTEGER Number of GPUs to use. ngpu > 0.

  [in]

  side

  magma_side_t
  - = MagmaLeft: apply Q or Q**H from the Left;
  - = MagmaRight: apply Q or Q**H from the Right.

  [in]

  uplo

  magma_uplo_t
  - = MagmaUpper: Upper triangle of A contains elementary reflectors from CHETRD;
  - = MagmaLower: Lower triangle of A contains elementary reflectors from CHETRD.

  [in]

  trans

  magma_trans_t
  - = MagmaNoTrans: No transpose, apply Q;
  - = Magma_ConjTrans: Conjugate transpose, apply Q**H.

  [in] | m | INTEGER The number of rows of the matrix C. M >= 0.
  [in] | n | INTEGER The number of columns of the matrix C. N >= 0.
  [in] | A | COMPLEX array, dimension (LDA,M) if SIDE = MagmaLeft (LDA,N) if SIDE = MagmaRight The vectors which define the elementary reflectors, as returned by CHETRD.
  [in] | lda | INTEGER The leading dimension of the array A. LDA >= max(1,M) if SIDE = MagmaLeft; LDA >= max(1,N) if SIDE = MagmaRight.
  [in] | tau | COMPLEX array, dimension (M-1) if SIDE = MagmaLeft (N-1) if SIDE = MagmaRight TAU(i) must contain the scalar factor of the elementary reflector H(i), as returned by CHETRD.
  [in,out] | C | COMPLEX array, dimension (LDC,N) On entry, the M-by-N matrix C. On exit, C is overwritten by Q*C or Q**H*C or C*Q**H or C*Q.
  [in] | ldc | INTEGER The leading dimension of the array C. LDC >= max(1,M).
  [out] | work | (workspace) COMPLEX array, dimension (MAX(1,LWORK)) On exit, if INFO = 0, WORK[0] returns the optimal LWORK.

  [in]

  lwork

  INTEGER The dimension of the array WORK. If SIDE = MagmaLeft, LWORK >= max(1,N); if SIDE = MagmaRight, LWORK >= max(1,M). For optimum performance LWORK >= N*NB if SIDE = MagmaLeft, and LWORK >= M*NB if SIDE = MagmaRight, where NB is the optimal blocksize.
  If LWORK = -1, then a workspace query is assumed; the routine only calculates the optimal size of the WORK array, returns this value as the first entry of the WORK array, and no error message related to LWORK is issued.

  [out]

  info

  INTEGER
  - = 0: successful exit
  - < 0: if INFO = -i, the i-th argument had an illegal value

## magma_dormtr()

magma_int_t magma_dormtr | ( | magma_side_t | side,
|  | magma_uplo_t | uplo,
|  | magma_trans_t | trans,
|  | magma_int_t | m,
|  | magma_int_t | n,
|  | double * | A,
|  | magma_int_t | lda,
|  | double * | tau,
|  | double * | C,
|  | magma_int_t | ldc,
|  | double * | work,
|  | magma_int_t | lwork,
|  | magma_int_t * | info )

DORMTR overwrites the general real M-by-N matrix C with.

                            SIDE = MagmaLeft    SIDE = MagmaRight

TRANS = MagmaNoTrans: Q * C C * Q TRANS = MagmaTrans: Q**H * C C * Q**H

where Q is a real orthogonal matrix of order nq, with nq = m if SIDE = MagmaLeft and nq = n if SIDE = MagmaRight. Q is defined as the product of nq-1 elementary reflectors, as returned by DSYTRD:

if UPLO = MagmaUpper, Q = H(nq-1) . . . H(2) H(1);

if UPLO = MagmaLower, Q = H(1) H(2) . . . H(nq-1).

Parameters

  [in]

  side

  magma_side_t
  - = MagmaLeft: apply Q or Q**H from the Left;
  - = MagmaRight: apply Q or Q**H from the Right.

  [in]

  uplo

  magma_uplo_t
  - = MagmaUpper: Upper triangle of A contains elementary reflectors from DSYTRD;
  - = MagmaLower: Lower triangle of A contains elementary reflectors from DSYTRD.

  [in]

  trans

  magma_trans_t
  - = MagmaNoTrans: No transpose, apply Q;
  - = MagmaTrans: Conjugate transpose, apply Q**H.

  [in] | m | INTEGER The number of rows of the matrix C. M >= 0.
  [in] | n | INTEGER The number of columns of the matrix C. N >= 0.
  [in] | A | DOUBLE PRECISION array, dimension (LDA,M) if SIDE = MagmaLeft (LDA,N) if SIDE = MagmaRight The vectors which define the elementary reflectors, as returned by DSYTRD.
  [in] | lda | INTEGER The leading dimension of the array A. LDA >= max(1,M) if SIDE = MagmaLeft; LDA >= max(1,N) if SIDE = MagmaRight.
  [in] | tau | DOUBLE PRECISION array, dimension (M-1) if SIDE = MagmaLeft (N-1) if SIDE = MagmaRight TAU(i) must contain the scalar factor of the elementary reflector H(i), as returned by DSYTRD.
  [in,out] | C | DOUBLE PRECISION array, dimension (LDC,N) On entry, the M-by-N matrix C. On exit, C is overwritten by Q*C or Q**H * C or C * Q**H or C*Q.
  [in] | ldc | INTEGER The leading dimension of the array C. LDC >= max(1,M).
  [out] | work | (workspace) DOUBLE PRECISION array, dimension (MAX(1,LWORK)) On exit, if INFO = 0, WORK[0] returns the optimal LWORK.

  [in]

  lwork

  INTEGER The dimension of the array WORK. If SIDE = MagmaLeft, LWORK >= max(1,N); if SIDE = MagmaRight, LWORK >= max(1,M). For optimum performance LWORK >= N*NB if SIDE = MagmaLeft, and LWORK >= M*NB if SIDE = MagmaRight, where NB is the optimal blocksize.
  If LWORK = -1, then a workspace query is assumed; the routine only calculates the optimal size of the WORK array, returns this value as the first entry of the WORK array, and no error message related to LWORK is issued.

  [out]

  info

  INTEGER
  - = 0: successful exit
  - < 0: if INFO = -i, the i-th argument had an illegal value

## magma_dormtr_gpu()

magma_int_t magma_dormtr_gpu | ( | magma_side_t | side,
|  | magma_uplo_t | uplo,
|  | magma_trans_t | trans,
|  | magma_int_t | m,
|  | magma_int_t | n,
|  | magmaDouble_ptr | dA,
|  | magma_int_t | ldda,
|  | double * | tau,
|  | magmaDouble_ptr | dC,
|  | magma_int_t | lddc,
|  | const double * | wA,
|  | magma_int_t | ldwa,
|  | magma_int_t * | info )

DORMTR overwrites the general real M-by-N matrix C with.

                            SIDE = MagmaLeft    SIDE = MagmaRight

TRANS = MagmaNoTrans: Q * C C * Q TRANS = MagmaTrans: Q**H * C C * Q**H

where Q is a real orthogonal matrix of order nq, with nq = m if SIDE = MagmaLeft and nq = n if SIDE = MagmaRight. Q is defined as the product of nq-1 elementary reflectors, as returned by DSYTRD:

if UPLO = MagmaUpper, Q = H(nq-1) . . . H(2) H(1);

if UPLO = MagmaLower, Q = H(1) H(2) . . . H(nq-1).

Parameters

  [in]

  side

  magma_side_t
  - = MagmaLeft: apply Q or Q**H from the Left;
  - = MagmaRight: apply Q or Q**H from the Right.

  [in]

  uplo

  magma_uplo_t
  - = MagmaUpper: Upper triangle of A contains elementary reflectors from DSYTRD;
  - = MagmaLower: Lower triangle of A contains elementary reflectors from DSYTRD.

  [in]

  trans

  magma_trans_t
  - = MagmaNoTrans: No transpose, apply Q;
  - = MagmaTrans: Conjugate transpose, apply Q**H.

  [in] | m | INTEGER The number of rows of the matrix C. M >= 0.
  [in] | n | INTEGER The number of columns of the matrix C. N >= 0.
  [in,out] | dA | DOUBLE PRECISION array, dimension (LDDA,M) if SIDE = MagmaLeft (LDDA,N) if SIDE = MagmaRight The vectors which define the elementary reflectors, as returned by DSYTRD_GPU. On output the diagonal, the subdiagonal and the upper part (UPLO=MagmaLower) or lower part (UPLO=MagmaUpper) are destroyed.
  [in] | ldda | INTEGER The leading dimension of the array dA. If SIDE = MagmaLeft, LDDA >= max(1,M); if SIDE = MagmaRight, LDDA >= max(1,N).
  [in] | tau | DOUBLE PRECISION array, dimension (M-1) if SIDE = MagmaLeft (N-1) if SIDE = MagmaRight TAU(i) must contain the scalar factor of the elementary reflector H(i), as returned by DSYTRD.
  [in,out] | dC | DOUBLE PRECISION array, dimension (LDDC,N) On entry, the M-by-N matrix C. On exit, C is overwritten by (Q*C) or (Q**H * C) or (C * Q**H) or (C*Q).
  [in] | lddc | INTEGER The leading dimension of the array C. LDDC >= max(1,M).
  [in] | wA | DOUBLE PRECISION array, dimension (LDWA,M) if SIDE = MagmaLeft (LDWA,N) if SIDE = MagmaRight The vectors which define the elementary reflectors, as returned by DSYTRD_GPU. (A copy of the upper or lower part of dA, on the host.)
  [in] | ldwa | INTEGER The leading dimension of the array wA. If SIDE = MagmaLeft, LDWA >= max(1,M); if SIDE = MagmaRight, LDWA >= max(1,N).

  [out]

  info

  INTEGER
  - = 0: successful exit
  - < 0: if INFO = -i, the i-th argument had an illegal value

## magma_dormtr_m()

magma_int_t magma_dormtr_m | ( | magma_int_t | ngpu,
|  | magma_side_t | side,
|  | magma_uplo_t | uplo,
|  | magma_trans_t | trans,
|  | magma_int_t | m,
|  | magma_int_t | n,
|  | double * | A,
|  | magma_int_t | lda,
|  | double * | tau,
|  | double * | C,
|  | magma_int_t | ldc,
|  | double * | work,
|  | magma_int_t | lwork,
|  | magma_int_t * | info )

DORMTR overwrites the general real M-by-N matrix C with.

                            SIDE = MagmaLeft    SIDE = MagmaRight

TRANS = MagmaNoTrans: Q * C C * Q TRANS = MagmaTrans: Q**H * C C * Q**H

where Q is a real orthogonal matrix of order nq, with nq = m if SIDE = MagmaLeft and nq = n if SIDE = MagmaRight. Q is defined as the product of nq-1 elementary reflectors, as returned by DSYTRD:

if UPLO = MagmaUpper, Q = H(nq-1) . . . H(2) H(1);

if UPLO = MagmaLower, Q = H(1) H(2) . . . H(nq-1).

Parameters

  [in] | ngpu | INTEGER Number of GPUs to use. ngpu > 0.

  [in]

  side

  magma_side_t
  - = MagmaLeft: apply Q or Q**H from the Left;
  - = MagmaRight: apply Q or Q**H from the Right.

  [in]

  uplo

  magma_uplo_t
  - = MagmaUpper: Upper triangle of A contains elementary reflectors from DSYTRD;
  - = MagmaLower: Lower triangle of A contains elementary reflectors from DSYTRD.

  [in]

  trans

  magma_trans_t
  - = MagmaNoTrans: No transpose, apply Q;
  - = MagmaTrans: Conjugate transpose, apply Q**H.

  [in] | m | INTEGER The number of rows of the matrix C. M >= 0.
  [in] | n | INTEGER The number of columns of the matrix C. N >= 0.
  [in] | A | DOUBLE PRECISION array, dimension (LDA,M) if SIDE = MagmaLeft (LDA,N) if SIDE = MagmaRight The vectors which define the elementary reflectors, as returned by DSYTRD.
  [in] | lda | INTEGER The leading dimension of the array A. LDA >= max(1,M) if SIDE = MagmaLeft; LDA >= max(1,N) if SIDE = MagmaRight.
  [in] | tau | DOUBLE PRECISION array, dimension (M-1) if SIDE = MagmaLeft (N-1) if SIDE = MagmaRight TAU(i) must contain the scalar factor of the elementary reflector H(i), as returned by DSYTRD.
  [in,out] | C | DOUBLE PRECISION array, dimension (LDC,N) On entry, the M-by-N matrix C. On exit, C is overwritten by Q*C or Q**H*C or C*Q**H or C*Q.
  [in] | ldc | INTEGER The leading dimension of the array C. LDC >= max(1,M).
  [out] | work | (workspace) DOUBLE PRECISION array, dimension (MAX(1,LWORK)) On exit, if INFO = 0, WORK[0] returns the optimal LWORK.

  [in]

  lwork

  INTEGER The dimension of the array WORK. If SIDE = MagmaLeft, LWORK >= max(1,N); if SIDE = MagmaRight, LWORK >= max(1,M). For optimum performance LWORK >= N*NB if SIDE = MagmaLeft, and LWORK >= M*NB if SIDE = MagmaRight, where NB is the optimal blocksize.
  If LWORK = -1, then a workspace query is assumed; the routine only calculates the optimal size of the WORK array, returns this value as the first entry of the WORK array, and no error message related to LWORK is issued.

  [out]

  info

  INTEGER
  - = 0: successful exit
  - < 0: if INFO = -i, the i-th argument had an illegal value

## magma_sormtr()

magma_int_t magma_sormtr | ( | magma_side_t | side,
|  | magma_uplo_t | uplo,
|  | magma_trans_t | trans,
|  | magma_int_t | m,
|  | magma_int_t | n,
|  | float * | A,
|  | magma_int_t | lda,
|  | float * | tau,
|  | float * | C,
|  | magma_int_t | ldc,
|  | float * | work,
|  | magma_int_t | lwork,
|  | magma_int_t * | info )

SORMTR overwrites the general real M-by-N matrix C with.

                            SIDE = MagmaLeft    SIDE = MagmaRight

TRANS = MagmaNoTrans: Q * C C * Q TRANS = MagmaTrans: Q**H * C C * Q**H

where Q is a real orthogonal matrix of order nq, with nq = m if SIDE = MagmaLeft and nq = n if SIDE = MagmaRight. Q is defined as the product of nq-1 elementary reflectors, as returned by SSYTRD:

if UPLO = MagmaUpper, Q = H(nq-1) . . . H(2) H(1);

if UPLO = MagmaLower, Q = H(1) H(2) . . . H(nq-1).

Parameters

  [in]

  side

  magma_side_t
  - = MagmaLeft: apply Q or Q**H from the Left;
  - = MagmaRight: apply Q or Q**H from the Right.

  [in]

  uplo

  magma_uplo_t
  - = MagmaUpper: Upper triangle of A contains elementary reflectors from SSYTRD;
  - = MagmaLower: Lower triangle of A contains elementary reflectors from SSYTRD.

  [in]

  trans

  magma_trans_t
  - = MagmaNoTrans: No transpose, apply Q;
  - = MagmaTrans: Conjugate transpose, apply Q**H.

  [in] | m | INTEGER The number of rows of the matrix C. M >= 0.
  [in] | n | INTEGER The number of columns of the matrix C. N >= 0.
  [in] | A | REAL array, dimension (LDA,M) if SIDE = MagmaLeft (LDA,N) if SIDE = MagmaRight The vectors which define the elementary reflectors, as returned by SSYTRD.
  [in] | lda | INTEGER The leading dimension of the array A. LDA >= max(1,M) if SIDE = MagmaLeft; LDA >= max(1,N) if SIDE = MagmaRight.
  [in] | tau | REAL array, dimension (M-1) if SIDE = MagmaLeft (N-1) if SIDE = MagmaRight TAU(i) must contain the scalar factor of the elementary reflector H(i), as returned by SSYTRD.
  [in,out] | C | REAL array, dimension (LDC,N) On entry, the M-by-N matrix C. On exit, C is overwritten by Q*C or Q**H * C or C * Q**H or C*Q.
  [in] | ldc | INTEGER The leading dimension of the array C. LDC >= max(1,M).
  [out] | work | (workspace) REAL array, dimension (MAX(1,LWORK)) On exit, if INFO = 0, WORK[0] returns the optimal LWORK.

  [in]

  lwork

  INTEGER The dimension of the array WORK. If SIDE = MagmaLeft, LWORK >= max(1,N); if SIDE = MagmaRight, LWORK >= max(1,M). For optimum performance LWORK >= N*NB if SIDE = MagmaLeft, and LWORK >= M*NB if SIDE = MagmaRight, where NB is the optimal blocksize.
  If LWORK = -1, then a workspace query is assumed; the routine only calculates the optimal size of the WORK array, returns this value as the first entry of the WORK array, and no error message related to LWORK is issued.

  [out]

  info

  INTEGER
  - = 0: successful exit
  - < 0: if INFO = -i, the i-th argument had an illegal value

## magma_sormtr_gpu()

magma_int_t magma_sormtr_gpu | ( | magma_side_t | side,
|  | magma_uplo_t | uplo,
|  | magma_trans_t | trans,
|  | magma_int_t | m,
|  | magma_int_t | n,
|  | magmaFloat_ptr | dA,
|  | magma_int_t | ldda,
|  | float * | tau,
|  | magmaFloat_ptr | dC,
|  | magma_int_t | lddc,
|  | const float * | wA,
|  | magma_int_t | ldwa,
|  | magma_int_t * | info )

SORMTR overwrites the general real M-by-N matrix C with.

                            SIDE = MagmaLeft    SIDE = MagmaRight

TRANS = MagmaNoTrans: Q * C C * Q TRANS = MagmaTrans: Q**H * C C * Q**H

where Q is a real orthogonal matrix of order nq, with nq = m if SIDE = MagmaLeft and nq = n if SIDE = MagmaRight. Q is defined as the product of nq-1 elementary reflectors, as returned by SSYTRD:

if UPLO = MagmaUpper, Q = H(nq-1) . . . H(2) H(1);

if UPLO = MagmaLower, Q = H(1) H(2) . . . H(nq-1).

Parameters

  [in]

  side

  magma_side_t
  - = MagmaLeft: apply Q or Q**H from the Left;
  - = MagmaRight: apply Q or Q**H from the Right.

  [in]

  uplo

  magma_uplo_t
  - = MagmaUpper: Upper triangle of A contains elementary reflectors from SSYTRD;
  - = MagmaLower: Lower triangle of A contains elementary reflectors from SSYTRD.

  [in]

  trans

  magma_trans_t
  - = MagmaNoTrans: No transpose, apply Q;
  - = MagmaTrans: Conjugate transpose, apply Q**H.

  [in] | m | INTEGER The number of rows of the matrix C. M >= 0.
  [in] | n | INTEGER The number of columns of the matrix C. N >= 0.
  [in,out] | dA | REAL array, dimension (LDDA,M) if SIDE = MagmaLeft (LDDA,N) if SIDE = MagmaRight The vectors which define the elementary reflectors, as returned by SSYTRD_GPU. On output the diagonal, the subdiagonal and the upper part (UPLO=MagmaLower) or lower part (UPLO=MagmaUpper) are destroyed.
  [in] | ldda | INTEGER The leading dimension of the array dA. If SIDE = MagmaLeft, LDDA >= max(1,M); if SIDE = MagmaRight, LDDA >= max(1,N).
  [in] | tau | REAL array, dimension (M-1) if SIDE = MagmaLeft (N-1) if SIDE = MagmaRight TAU(i) must contain the scalar factor of the elementary reflector H(i), as returned by SSYTRD.
  [in,out] | dC | REAL array, dimension (LDDC,N) On entry, the M-by-N matrix C. On exit, C is overwritten by (Q*C) or (Q**H * C) or (C * Q**H) or (C*Q).
  [in] | lddc | INTEGER The leading dimension of the array C. LDDC >= max(1,M).
  [in] | wA | REAL array, dimension (LDWA,M) if SIDE = MagmaLeft (LDWA,N) if SIDE = MagmaRight The vectors which define the elementary reflectors, as returned by SSYTRD_GPU. (A copy of the upper or lower part of dA, on the host.)
  [in] | ldwa | INTEGER The leading dimension of the array wA. If SIDE = MagmaLeft, LDWA >= max(1,M); if SIDE = MagmaRight, LDWA >= max(1,N).

  [out]

  info

  INTEGER
  - = 0: successful exit
  - < 0: if INFO = -i, the i-th argument had an illegal value

## magma_sormtr_m()

magma_int_t magma_sormtr_m | ( | magma_int_t | ngpu,
|  | magma_side_t | side,
|  | magma_uplo_t | uplo,
|  | magma_trans_t | trans,
|  | magma_int_t | m,
|  | magma_int_t | n,
|  | float * | A,
|  | magma_int_t | lda,
|  | float * | tau,
|  | float * | C,
|  | magma_int_t | ldc,
|  | float * | work,
|  | magma_int_t | lwork,
|  | magma_int_t * | info )

SORMTR overwrites the general real M-by-N matrix C with.

                            SIDE = MagmaLeft    SIDE = MagmaRight

TRANS = MagmaNoTrans: Q * C C * Q TRANS = MagmaTrans: Q**H * C C * Q**H

where Q is a real orthogonal matrix of order nq, with nq = m if SIDE = MagmaLeft and nq = n if SIDE = MagmaRight. Q is defined as the product of nq-1 elementary reflectors, as returned by SSYTRD:

if UPLO = MagmaUpper, Q = H(nq-1) . . . H(2) H(1);

if UPLO = MagmaLower, Q = H(1) H(2) . . . H(nq-1).

Parameters

  [in] | ngpu | INTEGER Number of GPUs to use. ngpu > 0.

  [in]

  side

  magma_side_t
  - = MagmaLeft: apply Q or Q**H from the Left;
  - = MagmaRight: apply Q or Q**H from the Right.

  [in]

  uplo

  magma_uplo_t
  - = MagmaUpper: Upper triangle of A contains elementary reflectors from SSYTRD;
  - = MagmaLower: Lower triangle of A contains elementary reflectors from SSYTRD.

  [in]

  trans

  magma_trans_t
  - = MagmaNoTrans: No transpose, apply Q;
  - = MagmaTrans: Conjugate transpose, apply Q**H.

  [in] | m | INTEGER The number of rows of the matrix C. M >= 0.
  [in] | n | INTEGER The number of columns of the matrix C. N >= 0.
  [in] | A | REAL array, dimension (LDA,M) if SIDE = MagmaLeft (LDA,N) if SIDE = MagmaRight The vectors which define the elementary reflectors, as returned by SSYTRD.
  [in] | lda | INTEGER The leading dimension of the array A. LDA >= max(1,M) if SIDE = MagmaLeft; LDA >= max(1,N) if SIDE = MagmaRight.
  [in] | tau | REAL array, dimension (M-1) if SIDE = MagmaLeft (N-1) if SIDE = MagmaRight TAU(i) must contain the scalar factor of the elementary reflector H(i), as returned by SSYTRD.
  [in,out] | C | REAL array, dimension (LDC,N) On entry, the M-by-N matrix C. On exit, C is overwritten by Q*C or Q**H*C or C*Q**H or C*Q.
  [in] | ldc | INTEGER The leading dimension of the array C. LDC >= max(1,M).
  [out] | work | (workspace) REAL array, dimension (MAX(1,LWORK)) On exit, if INFO = 0, WORK[0] returns the optimal LWORK.

  [in]

  lwork

  INTEGER The dimension of the array WORK. If SIDE = MagmaLeft, LWORK >= max(1,N); if SIDE = MagmaRight, LWORK >= max(1,M). For optimum performance LWORK >= N*NB if SIDE = MagmaLeft, and LWORK >= M*NB if SIDE = MagmaRight, where NB is the optimal blocksize.
  If LWORK = -1, then a workspace query is assumed; the routine only calculates the optimal size of the WORK array, returns this value as the first entry of the WORK array, and no error message related to LWORK is issued.

  [out]

  info

  INTEGER
  - = 0: successful exit
  - < 0: if INFO = -i, the i-th argument had an illegal value

## magma_zunmtr()

magma_int_t magma_zunmtr | ( | magma_side_t | side,
|  | magma_uplo_t | uplo,
|  | magma_trans_t | trans,
|  | magma_int_t | m,
|  | magma_int_t | n,
|  | magmaDoubleComplex * | A,
|  | magma_int_t | lda,
|  | magmaDoubleComplex * | tau,
|  | magmaDoubleComplex * | C,
|  | magma_int_t | ldc,
|  | magmaDoubleComplex * | work,
|  | magma_int_t | lwork,
|  | magma_int_t * | info )

ZUNMTR overwrites the general complex M-by-N matrix C with.

                            SIDE = MagmaLeft    SIDE = MagmaRight

TRANS = MagmaNoTrans: Q * C C * Q TRANS = Magma_ConjTrans: Q**H * C C * Q**H

where Q is a complex unitary matrix of order nq, with nq = m if SIDE = MagmaLeft and nq = n if SIDE = MagmaRight. Q is defined as the product of nq-1 elementary reflectors, as returned by ZHETRD:

if UPLO = MagmaUpper, Q = H(nq-1) . . . H(2) H(1);

if UPLO = MagmaLower, Q = H(1) H(2) . . . H(nq-1).

Parameters

  [in]

  side

  magma_side_t
  - = MagmaLeft: apply Q or Q**H from the Left;
  - = MagmaRight: apply Q or Q**H from the Right.

  [in]

  uplo

  magma_uplo_t
  - = MagmaUpper: Upper triangle of A contains elementary reflectors from ZHETRD;
  - = MagmaLower: Lower triangle of A contains elementary reflectors from ZHETRD.

  [in]

  trans

  magma_trans_t
  - = MagmaNoTrans: No transpose, apply Q;
  - = Magma_ConjTrans: Conjugate transpose, apply Q**H.

  [in] | m | INTEGER The number of rows of the matrix C. M >= 0.
  [in] | n | INTEGER The number of columns of the matrix C. N >= 0.
  [in] | A | COMPLEX_16 array, dimension (LDA,M) if SIDE = MagmaLeft (LDA,N) if SIDE = MagmaRight The vectors which define the elementary reflectors, as returned by ZHETRD.
  [in] | lda | INTEGER The leading dimension of the array A. LDA >= max(1,M) if SIDE = MagmaLeft; LDA >= max(1,N) if SIDE = MagmaRight.
  [in] | tau | COMPLEX_16 array, dimension (M-1) if SIDE = MagmaLeft (N-1) if SIDE = MagmaRight TAU(i) must contain the scalar factor of the elementary reflector H(i), as returned by ZHETRD.
  [in,out] | C | COMPLEX_16 array, dimension (LDC,N) On entry, the M-by-N matrix C. On exit, C is overwritten by Q*C or Q**H * C or C * Q**H or C*Q.
  [in] | ldc | INTEGER The leading dimension of the array C. LDC >= max(1,M).
  [out] | work | (workspace) COMPLEX_16 array, dimension (MAX(1,LWORK)) On exit, if INFO = 0, WORK[0] returns the optimal LWORK.

  [in]

  lwork

  INTEGER The dimension of the array WORK. If SIDE = MagmaLeft, LWORK >= max(1,N); if SIDE = MagmaRight, LWORK >= max(1,M). For optimum performance LWORK >= N*NB if SIDE = MagmaLeft, and LWORK >= M*NB if SIDE = MagmaRight, where NB is the optimal blocksize.
  If LWORK = -1, then a workspace query is assumed; the routine only calculates the optimal size of the WORK array, returns this value as the first entry of the WORK array, and no error message related to LWORK is issued.

  [out]

  info

  INTEGER
  - = 0: successful exit
  - < 0: if INFO = -i, the i-th argument had an illegal value

## magma_zunmtr_gpu()

magma_int_t magma_zunmtr_gpu | ( | magma_side_t | side,
|  | magma_uplo_t | uplo,
|  | magma_trans_t | trans,
|  | magma_int_t | m,
|  | magma_int_t | n,
|  | magmaDoubleComplex_ptr | dA,
|  | magma_int_t | ldda,
|  | magmaDoubleComplex * | tau,
|  | magmaDoubleComplex_ptr | dC,
|  | magma_int_t | lddc,
|  | const magmaDoubleComplex * | wA,
|  | magma_int_t | ldwa,
|  | magma_int_t * | info )

ZUNMTR overwrites the general complex M-by-N matrix C with.

                            SIDE = MagmaLeft    SIDE = MagmaRight

TRANS = MagmaNoTrans: Q * C C * Q TRANS = Magma_ConjTrans: Q**H * C C * Q**H

where Q is a complex unitary matrix of order nq, with nq = m if SIDE = MagmaLeft and nq = n if SIDE = MagmaRight. Q is defined as the product of nq-1 elementary reflectors, as returned by ZHETRD:

if UPLO = MagmaUpper, Q = H(nq-1) . . . H(2) H(1);

if UPLO = MagmaLower, Q = H(1) H(2) . . . H(nq-1).

Parameters

  [in]

  side

  magma_side_t
  - = MagmaLeft: apply Q or Q**H from the Left;
  - = MagmaRight: apply Q or Q**H from the Right.

  [in]

  uplo

  magma_uplo_t
  - = MagmaUpper: Upper triangle of A contains elementary reflectors from ZHETRD;
  - = MagmaLower: Lower triangle of A contains elementary reflectors from ZHETRD.

  [in]

  trans

  magma_trans_t
  - = MagmaNoTrans: No transpose, apply Q;
  - = Magma_ConjTrans: Conjugate transpose, apply Q**H.

  [in] | m | INTEGER The number of rows of the matrix C. M >= 0.
  [in] | n | INTEGER The number of columns of the matrix C. N >= 0.
  [in,out] | dA | COMPLEX_16 array, dimension (LDDA,M) if SIDE = MagmaLeft (LDDA,N) if SIDE = MagmaRight The vectors which define the elementary reflectors, as returned by ZHETRD_GPU. On output the diagonal, the subdiagonal and the upper part (UPLO=MagmaLower) or lower part (UPLO=MagmaUpper) are destroyed.
  [in] | ldda | INTEGER The leading dimension of the array dA. If SIDE = MagmaLeft, LDDA >= max(1,M); if SIDE = MagmaRight, LDDA >= max(1,N).
  [in] | tau | COMPLEX_16 array, dimension (M-1) if SIDE = MagmaLeft (N-1) if SIDE = MagmaRight TAU(i) must contain the scalar factor of the elementary reflector H(i), as returned by ZHETRD.
  [in,out] | dC | COMPLEX_16 array, dimension (LDDC,N) On entry, the M-by-N matrix C. On exit, C is overwritten by (Q*C) or (Q**H * C) or (C * Q**H) or (C*Q).
  [in] | lddc | INTEGER The leading dimension of the array C. LDDC >= max(1,M).
  [in] | wA | COMPLEX_16 array, dimension (LDWA,M) if SIDE = MagmaLeft (LDWA,N) if SIDE = MagmaRight The vectors which define the elementary reflectors, as returned by ZHETRD_GPU. (A copy of the upper or lower part of dA, on the host.)
  [in] | ldwa | INTEGER The leading dimension of the array wA. If SIDE = MagmaLeft, LDWA >= max(1,M); if SIDE = MagmaRight, LDWA >= max(1,N).

  [out]

  info

  INTEGER
  - = 0: successful exit
  - < 0: if INFO = -i, the i-th argument had an illegal value

## magma_zunmtr_m()

magma_int_t magma_zunmtr_m | ( | magma_int_t | ngpu,
|  | magma_side_t | side,
|  | magma_uplo_t | uplo,
|  | magma_trans_t | trans,
|  | magma_int_t | m,
|  | magma_int_t | n,
|  | magmaDoubleComplex * | A,
|  | magma_int_t | lda,
|  | magmaDoubleComplex * | tau,
|  | magmaDoubleComplex * | C,
|  | magma_int_t | ldc,
|  | magmaDoubleComplex * | work,
|  | magma_int_t | lwork,
|  | magma_int_t * | info )

ZUNMTR overwrites the general complex M-by-N matrix C with.

                            SIDE = MagmaLeft    SIDE = MagmaRight

TRANS = MagmaNoTrans: Q * C C * Q TRANS = Magma_ConjTrans: Q**H * C C * Q**H

where Q is a complex unitary matrix of order nq, with nq = m if SIDE = MagmaLeft and nq = n if SIDE = MagmaRight. Q is defined as the product of nq-1 elementary reflectors, as returned by ZHETRD:

if UPLO = MagmaUpper, Q = H(nq-1) . . . H(2) H(1);

if UPLO = MagmaLower, Q = H(1) H(2) . . . H(nq-1).

Parameters

  [in] | ngpu | INTEGER Number of GPUs to use. ngpu > 0.

  [in]

  side

  magma_side_t
  - = MagmaLeft: apply Q or Q**H from the Left;
  - = MagmaRight: apply Q or Q**H from the Right.

  [in]

  uplo

  magma_uplo_t
  - = MagmaUpper: Upper triangle of A contains elementary reflectors from ZHETRD;
  - = MagmaLower: Lower triangle of A contains elementary reflectors from ZHETRD.

  [in]

  trans

  magma_trans_t
  - = MagmaNoTrans: No transpose, apply Q;
  - = Magma_ConjTrans: Conjugate transpose, apply Q**H.

  [in] | m | INTEGER The number of rows of the matrix C. M >= 0.
  [in] | n | INTEGER The number of columns of the matrix C. N >= 0.
  [in] | A | COMPLEX_16 array, dimension (LDA,M) if SIDE = MagmaLeft (LDA,N) if SIDE = MagmaRight The vectors which define the elementary reflectors, as returned by ZHETRD.
  [in] | lda | INTEGER The leading dimension of the array A. LDA >= max(1,M) if SIDE = MagmaLeft; LDA >= max(1,N) if SIDE = MagmaRight.
  [in] | tau | COMPLEX_16 array, dimension (M-1) if SIDE = MagmaLeft (N-1) if SIDE = MagmaRight TAU(i) must contain the scalar factor of the elementary reflector H(i), as returned by ZHETRD.
  [in,out] | C | COMPLEX_16 array, dimension (LDC,N) On entry, the M-by-N matrix C. On exit, C is overwritten by Q*C or Q**H*C or C*Q**H or C*Q.
  [in] | ldc | INTEGER The leading dimension of the array C. LDC >= max(1,M).
  [out] | work | (workspace) COMPLEX_16 array, dimension (MAX(1,LWORK)) On exit, if INFO = 0, WORK[0] returns the optimal LWORK.

  [in]

  lwork

  INTEGER The dimension of the array WORK. If SIDE = MagmaLeft, LWORK >= max(1,N); if SIDE = MagmaRight, LWORK >= max(1,M). For optimum performance LWORK >= N*NB if SIDE = MagmaLeft, and LWORK >= M*NB if SIDE = MagmaRight, where NB is the optimal blocksize.
  If LWORK = -1, then a workspace query is assumed; the routine only calculates the optimal size of the WORK array, returns this value as the first entry of the WORK array, and no error message related to LWORK is issued.

  [out]

  info

  INTEGER
  - = 0: successful exit
  - < 0: if INFO = -i, the i-th argument had an illegal value